#version 330 core

#ifdef GL_ES
precision mediump float;
#endif

in  vec2 v_texCoords;
uniform sampler2D u_texture;
uniform sampler2D u_mask;
uniform sampler2D u_light;

out vec4 fragColor;

void main() {
    vec4 textureColor = texture(u_texture, v_texCoords);
    vec4 maskColor    = texture(u_mask,    v_texCoords);
    vec4 lightColor   = texture(u_light,   v_texCoords);

    // props
    if (maskColor.g > 0.1 && maskColor.r > 0.1) {
        vec3 minBright = max(lightColor.rgb, vec3(0.25));
        fragColor = vec4(textureColor.rgb * minBright, 1.0);
    }
    // wall
    else if (maskColor.r > 0.1) {
        fragColor = textureColor;
    }
    // wall borders
    else if (maskColor.g > 0.1) {
        vec3 minBright = max(lightColor.rgb, vec3(0.5));
        fragColor = vec4(textureColor.rgb * minBright, 1.0);
    }
    // background
    else {
        vec3 minBright = max(lightColor.rgb, vec3(0.1));
        fragColor = vec4(textureColor.rgb * minBright, 1.0);
    }
}
